
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Sequelize 和 MySQL 对照 / iVAN</title>

    <meta name="description" content="Sequelize 和 MySQL 对照 如果你觉得Sequelize的文档有点多.杂,不方便看,可以看看这篇. 在使用NodeJS来关系型操作数据库时,为了方便,通常都会选择一个合适的ORM(Object Relationship Model)框架.毕竟直接操作SQL比较繁琐,通过ORM框架,我们可以使用面向对象的方式来操作表.NodeJS社区有很多的ORM框架,我比较喜欢Sequelize,它功能丰富,可以非常方便的进行连表查询. 这篇文章我们就来看看,Sequelize是如何在SQL之上进行抽象.封装,从而提高开发效率的. 安装">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Sequelize 和 MySQL 对照</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><em>如果你觉得<a href="http://sequelize.readthedocs.org/en/latest/" rel="external nofollow noreferrer">Sequelize</a>的文档有点多、杂，不方便看，可以看看这篇。</em></p>
<p>在使用<code>NodeJS</code>来关系型操作数据库时，为了方便，通常都会选择一个合适的<code>ORM</code>（Object Relationship Model）框架。毕竟直接操作<code>SQL</code>比较繁琐，通过<code>ORM</code>框架，我们可以使用面向对象的方式来操作表。<code>NodeJS</code>社区有很多的<code>ORM</code>框架，我比较喜欢<code>Sequelize</code>，它功能丰富，可以非常方便的进行连表查询。</p>
<p>这篇文章我们就来看看，<code>Sequelize</code>是如何在<code>SQL</code>之上进行抽象、封装，从而提高开发效率的。</p>
<h1>安装</h1>
<p>这篇文章主要使用<code>MySQL</code>、<code>Sequelize</code>、<code>co</code>来进行介绍。安装非常简单：</p>
<pre><code>$ npm install --save co
$ npm install --save sequelize
$ npm install --save mysql</code></pre>
<p>代码模板如下：</p>
<pre><code>var Sequelize = require('sequelize');
var co = require('co');

co(function* () {
    // code here
}).catch(function(e) {
    console.log(e);
});</code></pre>
<p>基本上，<code>Sequelize</code>的操作都会返回一个<code>Promise</code>，在<code>co</code>的框架里面可以直接进行<code>yield</code>，非常方便。</p>
<h1>建立数据库连接</h1>
<p><pre><code>var sequelize = new Sequelize(
    'sample', // 数据库名
    'root',   // 用户名
    'zuki',   // 用户密码
    {
        'dialect': 'mysql',  // 数据库使用mysql
        'host': 'localhost', // 数据库服务器ip
        'port': 3306,        // 数据库服务器端口
        'define': {
            // 字段以下划线（_）来分割（默认是驼峰命名风格）
            'underscored': true
        }
    }
);</code></pre>

<h1>定义单张表</h1>
<p><code>Sequelize</code>：</p>
<pre><code>var User = sequelize.define(
    // 默认表名（一般这里写单数），生成时会自动转换成复数形式
    // 这个值还会作为访问模型相关的模型时的属性名，所以建议用小写形式
    'user',
    // 字段定义（主键、created_at、updated_at默认包含，不用特殊定义）
    {
        'emp_id': {
            'type': Sequelize.CHAR(10), // 字段类型
            'allowNull': false,         // 是否允许为NULL
            'unique': true              // 字段是否UNIQUE
        },
        'nick': {
            'type': Sequelize.CHAR(10),
            'allowNull': false
        },
        'department': {
            'type': Sequelize.STRING(64),
            'allowNull': true
        }
    }
);</code></pre>
<p><code>SQL</code>：</p>
<pre><code>CREATE TABLE IF NOT EXISTS `users` (
    `id` INTEGER NOT NULL auto_increment ,
    `emp_id` CHAR(10) NOT NULL UNIQUE,
    `nick` CHAR(10) NOT NULL,
    `department` VARCHAR(64),
    `created_at` DATETIME NOT NULL,
    `updated_at` DATETIME NOT NULL,
    PRIMARY KEY (`id`)
) ENGINE=InnoDB;</code></pre>
<p>几点说明：</p>
<ol>
<li>建表<code>SQL</code>会自动执行的意思是你主动调用<code>sync</code>的时候。类似这样：<code>User.sync({force: true});</code>（加<code>force:true</code>，会先删掉表后再建表）。我们也可以先定义好表结构，再来定义<code>Sequelize</code>模型，这时可以不用<code>sync</code>。两者在定义阶段没有什么关系，直到我们真正开始操作模型时，才会触及到表的操作，但是我们当然还是要尽量保证模型和表的同步（可以借助一些<code>migration</code>工具）。自动建表功能有风险，使用需谨慎。</li>
<li>所有数据类型，请参考文档<a href="http://sequelize.readthedocs.org/en/latest/api/datatypes/" rel="external nofollow noreferrer">数据类型</a>。</li>
<li>模型还可以定义虚拟属性、类方法、实例方法，请参考文档：<a href="http://sequelize.readthedocs.org/en/latest/docs/models-definition/" rel="external nofollow noreferrer">模型定义</a></li>
<li>其他一些特殊定义如下所示：
<pre><code>var User = sequelize.define(
    'user',
    {
        'emp_id': {
            'type': Sequelize.CHAR(10), // 字段类型
            'allowNull': false,         // 是否允许为NULL
            'unique': true              // 字段是否UNIQUE
        },
        'nick': {
            'type': Sequelize.CHAR(10),
            'allowNull': false
        },
        'department': {
            'type': Sequelize.STRING(64),
            'allowNull': true
        }
    },
    {
        // 自定义表名
        'freezeTableName': true,
        'tableName': 'xyz_users',

        // 是否需要增加createdAt、updatedAt、deletedAt字段
        'timestamps': true,

        // 不需要createdAt字段
        'createdAt': false,

        // 将updatedAt字段改个名
        'updatedAt': 'utime'

        // 将deletedAt字段改名
        // 同时需要设置paranoid为true（此种模式下，删除数据时不会进行物理删除，而是设置deletedAt为当前时间
        'deletedAt': 'dtime',
        'paranoid': true
    }
);</code></pre>
</li>
</ol>
<h1>单表增删改查</h1>
<p>通过<code>Sequelize</code>获取的模型对象都是一个<code>DAO</code>（Data Access Object）对象，这些对象会拥有许多操作数据库表的实例对象方法（比如：<code>save</code>、<code>update</code>、<code>destroy</code>等），需要获取“干净”的<code>JSON</code>对象可以调用<code>get({'plain': true})</code>。</p>
<p>通过模型的类方法可以获取模型对象（比如：<code>findById</code>、<code>findAll</code>等）。</p>
<h2>增</h2>
<p><code>Sequelize</code>：</p>
<pre><code>// 方法1：build后对象只存在于内存中，调用save后才操作db
var user = User.build({
    'emp_id': '1',
    'nick': '小红',
    'department': '技术部'
});
user = yield user.save();
console.log(user.get({'plain': true}));

// 方法2：直接操作db
var user = yield User.create({
    'emp_id': '2',
    'nick': '小明',
    'department': '技术部'
});
console.log(user.get({'plain': true}));</code></pre>
<p><code>SQL</code>：</p>
<pre><code>INSERT INTO `users`
(`id`, `emp_id`, `nick`, `department`, `updated_at`, `created_at`)
VALUES
(DEFAULT, '1', '小红', '技术部', '2015-11-02 14:49:54', '2015-11-02 14:49:54');</code></pre>
<p><code>Sequelize</code>会为主键<code>id</code>设置<code>DEFAULT</code>值来让数据库产生自增值，还将当前时间设置成了<code>created_at</code>和<code>updated_at</code>字段，非常方便。</p>
<h2>改</h2>
<p><code>Sequelize</code>：</p>
<pre><code>// 方法1：操作对象属性（不会操作db），调用save后操作db
user.nick = '小白';
user = yield user.save();
console.log(user.get({'plain': true}));

// 方法2：直接update操作db
user = yield user.update({
    'nick': '小白白'
});
console.log(user.get({'plain': true}));</code></pre>
<p><code>SQL</code>：</p>
<pre><code>UPDATE `users`
SET `nick` = '小白白', `updated_at` = '2015-11-02 15:00:04'
WHERE `id` = 1;</code></pre>
<p>更新操作时，<code>Sequelize</code>将将当前时间设置成了<code>updated_at</code>，非常方便。</p>
<p>如果想限制更新属性的白名单，可以这样写：</p>
<pre><code>// 方法1
user.emp_id = '33';
user.nick = '小白';
user = yield user.save({'fields': ['nick']});

// 方法2
user = yield user.update(
    {'emp_id': '33', 'nick': '小白'},
    {'fields': ['nick']}
});</code></pre>
<p>这样就只会更新<code>nick</code>字段，而<code>emp_id</code>会被忽略。这种方法在对表单提交过来的一大推数据中只更新某些属性的时候比较有用。</p>
<h2>删</h2>
<p><code>Sequelize</code>：</p>
<pre><code>yield user.destroy();</code></pre>
<p><code>SQL</code>：</p>
<pre><code>DELETE FROM `users` WHERE `id` = 1;</code></pre>
<p>这里有个特殊的地方是，如果我们开启了<code>paranoid</code>（偏执）模式，<code>destroy</code>的时候不会执行<code>DELETE</code>语句，而是执行一个<code>UPDATE</code>语句将<code>deleted_at</code>字段设置为当前时间（一开始此字段值为<code>NULL</code>）。我们可以使用<code>user.destroy({force: true})</code>来强制删除，从而执行<code>DELETE</code>语句进行物理删除。</p>
<h2>查</h2>
<h3>查全部</h3>
<p><code>Sequelize</code>：</p>
<pre><code>var users = yield User.findAll();
console.log(users);</code></pre>
<p><code>SQL</code>：</p>
<pre><code>SELECT `id`, `emp_id`, `nick`, `department`, `created_at`, `updated_at` FROM `users`;</code></pre>
<p><h3>限制字段</h3>
<p><code>Sequelize</code>：</p>
<pre><code>var users = yield User.findAll({
    'attributes': ['emp_id', 'nick']
});
console.log(users);</code></pre>
<p><code>SQL</code>：</p>
<pre><code>SELECT `emp_id`, `nick` FROM `users`;</code></pre>
<p><h3>字段重命名</h3>
<p><code>Sequelize</code>：</p>
<pre><code>var users = yield User.findAll({
    'attributes': [
        'emp_id', ['nick', 'user_nick']
    ]
});
console.log(users);</code></pre>
<p><code>SQL</code>：</p>
<pre><code>SELECT `emp_id`, `nick` AS `user_nick` FROM `users`;</code></pre>
<p><h3>where子句</h3>
<p><code>Sequelize</code>的<code>where</code>配置项基本上完全支持了<code>SQL</code>的<code>where</code>子句的功能，非常强大。我们一步步来进行介绍。</p>
<h4>基本条件</h4>
<p><code>Sequelize</code>：</p>
<pre><code>var users = yield User.findAll({
    'where': {
        'id': [1, 2, 3],
        'nick': 'a',
        'department': null
    }
});
console.log(users);</code></pre>
<p><code>SQL</code>：</p>
<pre><code>SELECT `id`, `emp_id`, `nick`, `department`, `created_at`, `updated_at`
FROM `users` AS `user`
WHERE
    `user`.`id` IN (1, 2, 3) AND
    `user`.`nick`='a' AND
    `user`.`department` IS NULL;</code></pre>
<p>可以看到，<code>k: v</code>被转换成了<code>k = v</code>，同时一个对象的多个<code>k: v</code>对被转换成了<code>AND</code>条件，即：<code>k1: v1, k2: v2</code>转换为<code>k1 = v1 AND k2 = v2</code>。</p>
<p>这里有2个要点：</p>
<ul>
<li>如果v是<code>null</code>，会转换为<code>IS NULL</code>（因为<code>SQL</code>没有<code>= NULL</code><br />
这种语法）</li>
<li>如果v是数组，会转换为<code>IN</code>条件（因为<code>SQL</code>没有<code>=[1,2,3]</code>这种语法，况且也没数组这种类型）</li>
</ul>
<h4>操作符</h4>
<p>操作符是对某个字段的进一步约束，可以有多个（对同一个字段的多个操作符会被转化为<code>AND</code>）。</p>
<p><code>Sequelize</code>：</p>
<pre><code>var users = yield User.findAll({
    'where': {
        'id': {
            '$eq': 1,                // id = 1
            '$ne': 2,                // id != 2

            '$gt': 6,                // id &gt; 6
            '$gte': 6,               // id &gt;= 6

            '$lt': 10,               // id &lt; 10
            '$lte': 10,              // id &lt;= 10

            '$between': [6, 10],     // id BETWEEN 6 AND 10
            '$notBetween': [11, 15], // id NOT BETWEEN 11 AND 15

            '$in': [1, 2],           // id IN (1, 2)
            '$notIn': [3, 4]         // id NOT IN (3, 4)
        },
        'nick': {
            '$like': '%a%',          // nick LIKE '%a%'
            '$notLike': '%a'         // nick NOT LIKE '%a'
        },
        'updated_at': {
            '$eq': null,             // updated_at IS NULL
            '$ne': null              // created_at IS NOT NULL
        }
    }
});</code></pre>
<p><code>SQL</code>：</p>
<pre><code>SELECT `id`, `emp_id`, `nick`, `department`, `created_at`, `updated_at`
FROM `users` AS `user`
WHERE
(
    `user`.`id` = 1 AND
    `user`.`id` != 2 AND
    `user`.`id` &gt; 6 AND
    `user`.`id` &gt;= 6 AND
    `user`.`id` &lt; 10 AND
    `user`.`id` &lt;= 10 AND
    `user`.`id` BETWEEN 6 AND 10 AND
    `user`.`id` NOT BETWEEN 11 AND 15 AND
    `user`.`id` IN (1, 2) AND
    `user`.`id` NOT IN (3, 4)
)
AND
(
    `user`.`nick` LIKE '%a%' AND
    `user`.`nick` NOT LIKE '%a'
)
AND
(
    `user`.`updated_at` IS NULL AND
    `user`.`updated_at` IS NOT NULL
);</code></pre>
<p>这里我们发现，其实相等条件<code>k: v</code>这种写法是操作符写法<code>k: {$eq: v}</code>的简写。而要实现不等条件就必须使用操作符写法<code>k: {$ne: v}</code>。</p>
<h4>条件</h4>
<p>上面我们说的条件查询，都是<code>AND</code>查询，<code>Sequelize</code>同时也支持<code>OR</code>、<code>NOT</code>、甚至多种条件的联合查询。</p>
<h5>AND条件</h5>
<p><code>Sequelize</code>：</p>
<pre><code>var users = yield User.findAll({
    'where': {
        '$and': [
            {'id': [1, 2]},
            {'nick': null}
        ]
    }
});</code></pre>
<p><code>SQL</code>：</p>
<pre><code>SELECT `id`, `emp_id`, `nick`, `department`, `created_at`, `updated_at`
FROM `users` AS `user`
WHERE
(
    `user`.`id` IN (1, 2) AND
    `user`.`nick` IS NULL
);</code></pre>
<p><h5>OR条件</h5>
<p><code>Sequelize</code>：</p>
<pre><code>var users = yield User.findAll({
    'where': {
        '$or': [
            {'id': [1, 2]},
            {'nick': null}
        ]
    }
});</code></pre>
<p><code>SQL</code>：</p>
<pre><code>SELECT `id`, `emp_id`, `nick`, `department`, `created_at`, `updated_at`
FROM `users` AS `user`
WHERE
(
    `user`.`id` IN (1, 2) OR
    `user`.`nick` IS NULL
);</code></pre>
<p><h5>NOT条件</h5>
<p><code>Sequelize</code>：</p>
<pre><code>var users = yield User.findAll({
    'where': {
        '$not': [
            {'id': [1, 2]},
            {'nick': null}
        ]
    }
});</code></pre>
<p><code>SQL</code>：</p>
<pre><code>SELECT `id`, `emp_id`, `nick`, `department`, `created_at`, `updated_at`
FROM `users` AS `user`
WHERE
NOT (
    `user`.`id` IN (1, 2) AND
    `user`.`nick` IS NULL
);</code></pre>
<p><h4>转换规则</h4>
<p>我们这里做个总结。<code>Sequelize</code>对<code>where</code>配置的转换规则的伪代码大概如下：</p>
<pre><code>function translate(where) {

    for (k, v of where) {

        if (k == 表字段) {
            // 先统一转为操作符形式
            if (v == 基本值) { // k: 'xxx'
                v = {'$eq': v};
            }
            if (v == 数组) { // k: [1, 2, 3]
                v = {'$in': v};
            }

            // 操作符转换
            for (opk, opv of v) {
                // op将opk转换对应的SQL表示
                =&gt; k + op(opk, opv) + AND;
            }
        }

        // 逻辑操作符处理

        if (k == '$and') {
            for (item in v) {
                =&gt; translate(item) + AND;
            }
        }

        if (k == '$or') {
            for (item in v) {
                =&gt; translate(item) + OR;
            }
        }

        if (k == '$not') {
            NOT +
            for (item in v) {
                =&gt; translate(item) + AND;
            }
        }

    }

    function op(opk, opv) {
        switch (opk) {
            case $eq =&gt; ('=' + opv) || 'IS NULL';
            case $ne =&gt; ('!=' + opv) || 'IS NOT NULL';
            case $gt =&gt; '&gt;' + opv;
            case $lt =&gt; '&lt;' + opv;
            case $gte =&gt; '&gt;=' + opv;
            case $lte =&gt; '&lt;=' + opv;
            case $between =&gt; 'BETWEEN ' + opv[0] + ' AND ' + opv[1];
            case $notBetween =&gt; 'NOT BETWEEN ' + opv[0] + ' AND ' + opv[1];
            case $in =&gt; 'IN (' + opv.join(',') + ')';
            case $notIn =&gt; 'NOT IN (' + opv.join(',') + ')';
            case $like =&gt; 'LIKE ' + opv;
            case $notLike =&gt; 'NOT LIKE ' + opv;
        }
    }

}</code></pre>
<p>我们看一个复杂例子，基本上就是按上述流程来进行转换。</p>
<p><code>Sequelize</code>：</p>
<pre><code>var users = yield User.findAll({
    'where': {
        'id': [3, 4],
        '$not': [
            {
                'id': {
                    '$in': [1, 2]
                }
            },
            {
                '$or': [
                    {'id': [1, 2]},
                    {'nick': null}
                ]
            }
        ],
        '$and': [
            {'id': [1, 2]},
            {'nick': null}
        ],
        '$or': [
            {'id': [1, 2]},
            {'nick': null}
        ]
    }
});</code></pre>
<p><code>SQL</code>：</p>
<pre><code>SELECT `id`, `emp_id`, `nick`, `department`, `created_at`, `updated_at`
FROM `users` AS `user`
WHERE
    `user`.`id` IN (3, 4)
AND
NOT
(
    `user`.`id` IN (1, 2)
    AND
    (`user`.`id` IN (1, 2) OR `user`.`nick` IS NULL)
)
AND
(
    `user`.`id` IN (1, 2) AND `user`.`nick` IS NULL
)
AND
(
    `user`.`id` IN (1, 2) OR `user`.`nick` IS NULL
);</code></pre>
<p><h4>排序</h4>
<p><code>Sequelize</code>：</p>
<pre><code>var users = yield User.findAll({
    'order': [
        ['id', 'DESC'],
        ['nick']
    ]
});</code></pre>
<p><code>SQL</code>：</p>
<pre><code>SELECT `id`, `emp_id`, `nick`, `department`, `created_at`, `updated_at`
FROM `users` AS `user`
ORDER BY `user`.`id` DESC, `user`.`nick`;</code></pre>
<p><h4>分页</h4>
<p><code>Sequelize</code>：</p>
<pre><code>var countPerPage = 20, currentPage = 5;
var users = yield User.findAll({
    'limit': countPerPage,                      // 每页多少条
    'offset': countPerPage * (currentPage - 1)  // 跳过多少条
});</code></pre>
<p><code>SQL</code>：</p>
<pre><code>SELECT `id`, `emp_id`, `nick`, `department`, `created_at`, `updated_at`
FROM `users` AS `user`
LIMIT 80, 20;</code></pre>
<p><h4>其他查询方法</h4>
<h5>查询一条数据</h5>
<p><code>Sequelize</code>：</p>
<pre><code>user = yield User.findById(1);

user = yield User.findOne({
    'where': {'nick': 'a'}
});</code></pre>
<p><code>SQL</code>：</p>
<pre><code>SELECT `id`, `emp_id`, `nick`, `department`, `created_at`, `updated_at`
FROM `users` AS `user`
WHERE `user`.`id` = 1 LIMIT 1;

SELECT `id`, `emp_id`, `nick`, `department`, `created_at`, `updated_at`
FROM `users` AS `user`
WHERE `user`.`nick` = 'a' LIMIT 1;</code></pre>
<p><h5>查询并获取数量</h5>
<p><code>Sequelize</code>：</p>
<pre><code>var result = yield User.findAndCountAll({
    'limit': 20,
    'offset': 0
});
console.log(result);</code></pre>
<p><code>SQL</code>：</p>
<pre><code>SELECT count(*) AS `count` FROM `users` AS `user`;

SELECT `id`, `emp_id`, `nick`, `department`, `created_at`, `updated_at`
FROM `users` AS `user`
LIMIT 20;</code></pre>
<p>这个方法会执行2个<code>SQL</code>，返回的<code>result</code>对象将包含2个字段：<code>result.count</code>是数据总数，<code>result.rows</code>是符合查询条件的所有数据。</p>
<h2>批量操作</h2>
<h3>插入</h3>
<p><code>Sequelize</code>：</p>
<pre><code>var users = yield User.bulkCreate(
    [
        {'emp_id': 'a', 'nick': 'a'},
        {'emp_id': 'b', 'nick': 'b'},
        {'emp_id': 'c', 'nick': 'c'}
    ]
);</code></pre>
<p><code>SQL</code>：</p>
<pre><code>INSERT INTO `users`
    (`id`,`emp_id`,`nick`,`created_at`,`updated_at`)
VALUES
    (NULL,'a','a','2015-11-03 02:43:30','2015-11-03 02:43:30'),
    (NULL,'b','b','2015-11-03 02:43:30','2015-11-03 02:43:30'),
    (NULL,'c','c','2015-11-03 02:43:30','2015-11-03 02:43:30');</code></pre>
<p>这里需要注意，返回的<code>users</code>数组里面每个对象的<code>id</code>值会是<code>null</code>。如果需要<code>id</code>值，可以重新取下数据。</p>
<h3>更新</h3>
<p><code>Sequelize</code>：</p>
<pre><code>var affectedRows = yield User.update(
    {'nick': 'hhhh'},
    {
        'where': {
            'id': [2, 3, 4]
        }
    }
);</code></pre>
<p><code>SQL</code>：</p>
<pre><code>UPDATE `users`
SET `nick`='hhhh',`updated_at`='2015-11-03 02:51:05'
WHERE `id` IN (2, 3, 4);</code></pre>
<p>这里返回的<code>affectedRows</code>其实是一个数组，里面只有一个元素，表示更新的数据条数（看起来像是<code>Sequelize</code>的一个<code>bug</code>）。</p>
<h3>删除</h3>
<p><code>Sequelize</code>：</p>
<pre><code>var affectedRows = yield User.destroy({
    'where': {'id': [2, 3, 4]}
});</code></pre>
<p><code>SQL</code>：</p>
<pre><code>DELETE FROM `users` WHERE `id` IN (2, 3, 4);</code></pre>
<p>这里返回的<code>affectedRows</code>是一个数字，表示删除的数据条数。</p>
<h1>关系</h1>
<p>关系一般有三种：一对一、一对多、多对多。<code>Sequelize</code>提供了清晰易用的接口来定义关系、进行表间的操作。</p>
<p>当说到关系查询时，一般会需要获取多张表的数据。有建议用连表查询<code>join</code>的，有不建议的。我的看法是，<code>join</code>查询这种黑科技在数据量小的情况下可以使用，基本没有什么影响，数据量大的时候，<code>join</code>的性能可能会是硬伤，应该尽量避免，可以分别根据索引取单表数据然后在应用层对数据进行<code>join</code>、<code>merge</code>。当然，查询时一定要分页，不要<code>findAll</code>。</p>
<h2>一对一</h2>
<h3>模型定义</h3>
<p><code>Sequelize</code>：</p>
<pre><code>var User = sequelize.define('user',
    {
        'emp_id': {
            'type': Sequelize.CHAR(10),
            'allowNull': false,
            'unique': true
        }
    }
);
var Account = sequelize.define('account',
    {
        'email': {
            'type': Sequelize.CHAR(20),
            'allowNull': false
        }
    }
);

/*
 * User的实例对象将拥有getAccount、setAccount、addAccount方法
 */
User.hasOne(Account);
/*
 * Account的实例对象将拥有getUser、setUser、addUser方法
 */
Account.belongsTo(User);
SQL：
CREATE TABLE IF NOT EXISTS `users` (
    `id` INTEGER NOT NULL auto_increment ,
    `emp_id` CHAR(10) NOT NULL UNIQUE,
    `created_at` DATETIME NOT NULL,
    `updated_at` DATETIME NOT NULL,
    PRIMARY KEY (`id`)
) ENGINE=InnoDB;

CREATE TABLE IF NOT EXISTS `accounts` (
    `id` INTEGER NOT NULL auto_increment ,
    `email` CHAR(20) NOT NULL,
    `created_at` DATETIME NOT NULL,
    `updated_at` DATETIME NOT NULL,
    `user_id` INTEGER,
    PRIMARY KEY (`id`),
    FOREIGN KEY (`user_id`) REFERENCES `users` (`id`) ON DELETE SET NULL ON UPDATE CASCADE
) ENGINE=InnoDB;</code></pre>
<p>可以看到，这种关系中外键<code>user_id</code>加在了<code>Account</code>上。另外，<code>Sequelize</code>还给我们生成了外键约束。</p>
<p>一般来说，外键约束在有些自己定制的数据库系统里面是禁止的，因为会带来一些性能问题。所以，建表的<code>SQL</code>一般就去掉约束，同时给外键加一个索引（加速查询），数据的一致性就靠应用层来保证了。</p>
<h3>关系操作</h3>
<h4>增</h4>
<p><code>Sequelize</code>：</p>
<pre><code>var user = yield User.create({'emp_id': '1'});
var account = user.createAccount({'email': 'a'});
console.log(account.get({'plain': true}));</code></pre>
<p><code>SQL</code>：</p>
<pre><code>INSERT INTO `users`
(`id`,`emp_id`,`updated_at`,`created_at`)
VALUES
(DEFAULT,'1','2015-11-03 06:24:53','2015-11-03 06:24:53');

INSERT INTO `accounts`
(`id`,`email`,`user_id`,`updated_at`,`created_at`)
VALUES
(DEFAULT,'a',1,'2015-11-03 06:24:53','2015-11-03 06:24:53');</code></pre>
<p><code>SQL</code>执行逻辑是：</p>
<ul>
<li>使用对应的的<code>user_id</code>作为外键在<code>accounts</code>表里插入一条数据。</li>
</ul>
<h4>改</h4>
<p><code>Sequelize</code>：</p>
<pre><code>var anotherAccount = yield Account.create({'email': 'b'});
console.log(anotherAccount);
anotherAccount = yield user.setAccount(anotherAccount);
console.log(anotherAccount);</code></pre>
<p><code>SQL</code>：</p>
<pre><code>INSERT INTO `accounts`
(`id`,`email`,`updated_at`,`created_at`)
VALUES
(DEFAULT,'b','2015-11-03 06:37:14','2015-11-03 06:37:14');

SELECT `id`, `email`, `created_at`, `updated_at`, `user_id`
FROM `accounts` AS `account` WHERE (`account`.`user_id` = 1);

UPDATE `accounts` SET `user_id`=NULL,`updated_at`='2015-11-03 06:37:14' WHERE `id` = 1;
UPDATE `accounts` SET `user_id`=1,`updated_at`='2015-11-03 06:37:14' WHERE `id` = 2;</code></pre>
<p><code>SQL</code>执行逻辑是：</p>
<ul>
<li>插入一条<code>account</code>数据，此时外键<code>user_id</code>是空的，还没有关联user</li>
<li>找出当前<code>user</code>所关联的<code>account</code>并将其<code>user_id</code>置为`NUL（为了保证一对一关系）</li>
<li>设置新的<code>acount</code>的外键<code>user_id</code>为<code>user</code>的属性<code>id</code>，生成关系</li>
</ul>
<h4>删</h4>
<p><code>Sequelize</code>：</p>
<pre><code>yield user.setAccount(null);</code></pre>
<p><code>SQL</code>：</p>
<pre><code>SELECT `id`, `email`, `created_at`, `updated_at`, `user_id`
FROM `accounts` AS `account`
WHERE (`account`.`user_id` = 1);

UPDATE `accounts`
SET `user_id`=NULL,`updated_at`='2015-11-04 00:11:35'
WHERE `id` = 1;</code></pre>
<p>这里的删除实际上只是“切断”关系，并不会真正的物理删除记录。</p>
<p><code>SQL</code>执行逻辑是：</p>
<ul>
<li>找出<code>user</code>所关联的<code>account</code>数据</li>
<li>将其外键<code>user_id</code>设置为<code>NULL</code>，完成关系的“切断”</li>
</ul>
<h4>查</h4>
<p><code>Sequelize</code>：</p>
<pre><code>var account = yield user.getAccount();
console.log(account);</code></pre>
<p><code>SQL</code>：</p>
<pre><code>SELECT `id`, `email`, `created_at`, `updated_at`, `user_id`
FROM `accounts` AS `account`
WHERE (`account`.`user_id` = 1);</code></pre>
<p>这里就是调用<code>user</code>的<code>getAccount</code>方法，根据外键来获取对应的<code>account</code>。</p>
<p>但是其实我们用面向对象的思维来思考应该是获取<code>user</code>的时候就能通过<code>user.account</code>的方式来访问<code>account</code>对象。这可以通过<code>Sequelize</code>的<code>eager loading</code>（急加载，和懒加载相反）来实现。</p>
<p><code>eager loading</code>的含义是说，取一个模型的时候，同时也把相关的模型数据也给我取过来（我很着急，不能按默认那种取一个模型就取一个模型的方式，我还要更多）。方法如下：</p>
<p><code>Sequelize</code>：</p>
<pre><code>var user = yield User.findById(1, {
    'include': [Account]
});
console.log(user.get({'plain': true}));
/*
 * 输出类似：
 { id: 1,
  emp_id: '1',
  created_at: Tue Nov 03 2015 15:25:27 GMT+0800 (CST),
  updated_at: Tue Nov 03 2015 15:25:27 GMT+0800 (CST),
  account:
   { id: 2,
     email: 'b',
     created_at: Tue Nov 03 2015 15:25:27 GMT+0800 (CST),
     updated_at: Tue Nov 03 2015 15:25:27 GMT+0800 (CST),
     user_id: 1 } }
 */</code></pre>
<p><code>SQL</code>：</p>
<pre><code>SELECT `user`.`id`, `user`.`emp_id`, `user`.`created_at`, `user`.`updated_at`, `account`.`id` AS `account.id`, `account`.`email` AS `account.email`, `account`.`created_at` AS `account.created_at`, `account`.`updated_at` AS `account.updated_at`, `account`.`user_id` AS `account.user_id`
FROM `users` AS `user` LEFT OUTER JOIN `accounts` AS `account`
ON `user`.`id` = `account`.`user_id`
WHERE `user`.`id` = 1 LIMIT 1;</code></pre>
<p>可以看到，我们对2个表进行了一个外联接，从而在取<code>user</code>的同时也获取到了<code>account</code>。</p>
<h4>其他补充说明</h4>
<p>如果我们重复调用<code>user.createAccount</code>方法，实际上会在数据库里面生成多条<code>user_id</code>一样的数据，并不是真正的一对一。</p>
<p>所以，在应用层保证一致性时，就需要我们遵循良好的编码约定。新增就用<code>user.createAccount</code>，更改就用<code>user.setAccount</code>。</p>
<p>也可以给<code>user_id</code>加一个<code>UNIQUE</code>约束，在数据库层面保证一致性，这时就需要做好<code>try/catch</code>，发生插入异常的时候能够知道是因为插入了多个<code>account</code>。</p>
<p>另外，我们上面都是使用<code>user</code>来对<code>account</code>进行操作。实际上反向操作也是可以的，这是因为我们定义了<code>Account.belongsTo(User)</code>。在<code>Sequelize</code>里面定义关系时，关系的调用方会获得相关的“关系”方法，一般为了两边都能操作，会同时定义双向关系（这里双向关系指的是模型层面，并不会在数据库表中出现两个表都加上外键的情况，请放心）。</p>
<h2>一对多</h2>
<h3>模型定义</h3>
<p><code>Sequelize</code>：</p>
<pre><code>var User = sequelize.define('user',
    {
        'emp_id': {
            'type': Sequelize.CHAR(10),
            'allowNull': false,
            'unique': true
        }
    }
);
var Note = sequelize.define('note',
    {
        'title': {
            'type': Sequelize.CHAR(64),
            'allowNull': false
        }
    }
);

/*
 * User的实例对象将拥有getNotes、setNotes、addNote、createNote、removeNote、hasNote方法
 */
User.hasMany(Note);
/*
 * Note的实例对象将拥有getUser、setUser、createUser方法
 */
Note.belongsTo(User);</code></pre>
<p><code>SQL</code>：</p>
<pre><code>CREATE TABLE IF NOT EXISTS `users` (
    `id` INTEGER NOT NULL auto_increment ,
    `emp_id` CHAR(10) NOT NULL UNIQUE,
    `created_at` DATETIME NOT NULL,
    `updated_at` DATETIME NOT NULL,
    PRIMARY KEY (`id`)
) ENGINE=InnoDB;

CREATE TABLE IF NOT EXISTS `notes` (
    `id` INTEGER NOT NULL auto_increment ,
    `title` CHAR(64) NOT NULL,
    `created_at` DATETIME NOT NULL,
    `updated_at` DATETIME NOT NULL,
    `user_id` INTEGER,
    PRIMARY KEY (`id`),
    FOREIGN KEY (`user_id`) REFERENCES `users` (`id`) ON DELETE SET NULL ON UPDATE CASCADE
) ENGINE=InnoDB;</code></pre>
<p>可以看到这种关系中，外键<code>user_id</code>加在了多的一端（<code>notes</code>表）。同时相关的模型也自动获得了一些方法。</p>
<h3>关系操作</h3>
<h4>增</h4>
<h5>方法1</h5>
<p><code>Sequelize</code>：</p>
<pre><code>var user = yield User.create({'emp_id': '1'});
var note = yield user.createNote({'title': 'a'});
console.log(note);</code></pre>
<p><code>SQL</code>：</p>
<pre><code>NSERT INTO `users`
(`id`,`emp_id`,`updated_at`,`created_at`)
VALUES
(DEFAULT,'1','2015-11-03 23:52:05','2015-11-03 23:52:05');

INSERT INTO `notes`
(`id`,`title`,`user_id`,`updated_at`,`created_at`)
VALUES
(DEFAULT,'a',1,'2015-11-03 23:52:05','2015-11-03 23:52:05');</code></pre>
<p><code>SQL</code>执行逻辑：</p>
<ul>
<li>使用<code>user</code>的主键<code>id</code>值作为外键直接在<code>notes</code>表里插入一条数据。</li>
</ul>
<h5>方法2</h5>
<p><code>Sequelize</code>：</p>
<pre><code>var user = yield User.create({'emp_id': '1'});
var note = yield Note.create({'title': 'b'});
yield user.addNote(note);</code></pre>
<p><code>SQL</code>：</p>
<pre><code>INSERT INTO `users`
(`id`,`emp_id`,`updated_at`,`created_at`)
VALUES
(DEFAULT,'1','2015-11-04 00:02:56','2015-11-04 00:02:56');

INSERT INTO `notes`
(`id`,`title`,`updated_at`,`created_at`)
VALUES
(DEFAULT,'b','2015-11-04 00:02:56','2015-11-04 00:02:56');

UPDATE `notes`
SET `user_id`=1,`updated_at`='2015-11-04 00:02:56'
WHERE `id` IN (1);</code></pre>
<p><code>SQL</code>执行逻辑：</p>
<ul>
<li>插入一条<code>note</code>数据，此时该条数据的外键<code>user_id</code>为空</li>
<li>使用<code>user</code>的属性<code>id</code>值再更新该条<code>note</code>数据，设置好外键，完成关系建立</li>
</ul>
<h4>改</h4>
<p><code>Sequelize</code>：</p>
<pre><code>// 为user增加note1、note2
var user = yield User.create({'emp_id': '1'});
var note1 = yield user.createNote({'title': 'a'});
var note2 = yield user.createNote({'title': 'b'});
// 先创建note3、note4
var note3 = yield Note.create({'title': 'c'});
var note4 = yield Note.create({'title': 'd'});
// user拥有的note更改为note3、note4
yield user.setNotes([note3, note4]);</code></pre>
<p><code>SQL</code>：</p>
<pre><code>/* 省去了创建语句 */
SELECT `id`, `title`, `created_at`, `updated_at`, `user_id`
FROM `notes` AS `note` WHERE `note`.`user_id` = 1;

UPDATE `notes`
SET `user_id`=NULL,`updated_at`='2015-11-04 12:45:12'
WHERE `id` IN (1, 2);

UPDATE `notes`
SET `user_id`=1,`updated_at`='2015-11-04 12:45:12'
WHERE `id` IN (3, 4);</code></pre>
<p><code>SQL</code>执行逻辑：</p>
<ul>
<li>根据<code>user</code>的属性<code>id</code>查询所有相关的<code>note</code>数据</li>
<li>将<code>note1</code>、<code>note2</code>的外键<code>user_id</code>置为<code>NULL</code>，切断关系</li>
<li>将<code>note3</code>、<code>note4</code>的外键<code>user_id</code>置为<code>user</code>的属性<code>id</code>，完成关系建立</li>
</ul>
<p>这里为啥还要查出所有的<code>note</code>数据呢？因为我们需要根据传人<code>setNotes</code>的数组来计算出哪些<code>note</code>要切断关系、哪些要新增关系，所以就需要查出来进行一个计算集合的“交集”运算。</p>
<h4>删</h4>
<p><code>Sequelize</code>：</p>
<pre><code>var user = yield User.create({'emp_id': '1'});
var note1 = yield user.createNote({'title': 'a'});
var note2 = yield user.createNote({'title': 'b'});
yield user.setNotes([]);</code></pre>
<p><code>SQL</code>：</p>
<pre><code>SELECT `id`, `title`, `created_at`, `updated_at`, `user_id`
FROM `notes` AS `note` WHERE `note`.`user_id` = 1;

UPDATE `notes`
SET `user_id`=NULL,`updated_at`='2015-11-04 12:50:08'
WHERE `id` IN (1, 2);</code></pre>
<p>实际上，上面说到的“改”已经有“删”的操作了（去掉<code>note1</code>、<code>note2</code>的关系）。这里的操作是删掉用户的所有<code>note</code>数据，直接执行<code>user.setNotes([])</code>即可。</p>
<p><code>SQL</code>执行逻辑：</p>
<ul>
<li>根据<code>user</code>的属性<code>id</code>查出所有相关的<code>note</code>数据</li>
<li>将其外键<code>user_id</code>置为<code>NULL</code>，切断关系</li>
</ul>
<p>还有一个真正的删除方法，就是<code>removeNote</code>。如下所示：</p>
<p><code>Sequelize</code>：</p>
<pre><code>yield user.removeNote(note);</code></pre>
<p><code>SQL</code>：</p>
<pre><code>UPDATE `notes`
SET `user_id`=NULL,`updated_at`='2015-11-06 01:40:12'
WHERE `user_id` = 1 AND `id` IN (1);</code></pre>
<p><h4>查</h4>
<h5>情况1</h5>
<p>查询<code>user</code>的所有满足条件的<code>note</code>数据。</p>
<p><code>Sequelize</code>：</p>
<pre><code>var notes = yield user.getNotes({
    'where': {
        'title': {
            '$like': '%css%'
        }
    }
});
notes.forEach(function(note) {
    console.log(note);
});</code></pre>
<p><code>SQL</code>：</p>
<pre><code>SELECT `id`, `title`, `created_at`, `updated_at`, `user_id`
FROM `notes` AS `note`
WHERE (`note`.`user_id` = 1 AND `note`.`title` LIKE '%a%');</code></pre>
<p>这种方法的<code>SQL</code>很简单，直接根据<code>user</code>的<code>id</code>值来查询满足条件的<code>note</code>即可。</p>
<h5>情况2</h5>
<p>查询所有满足条件的<code>note</code>，同时获取<code>note</code>属于哪个<code>user</code>。</p>
<p><code>Sequelize</code>：</p>
<pre><code>var notes = yield Note.findAll({
    'include': [User],
    'where': {
        'title': {
            '$like': '%css%'
        }
    }
});
notes.forEach(function(note) {
    // note属于哪个user可以通过note.user访问
    console.log(note);
});</code></pre>
<p><code>SQL</code>：</p>
<pre><code>SELECT `note`.`id`, `note`.`title`, `note`.`created_at`, `note`.`updated_at`, `note`.`user_id`,
`user`.`id` AS `user.id`, `user`.`emp_id` AS `user.emp_id`, `user`.`created_at` AS `user.created_at`, `user`.`updated_at` AS `user.updated_at`
FROM `notes` AS `note` LEFT OUTER JOIN `users` AS `user`
ON `note`.`user_id` = `user`.`id`
WHERE `note`.`title` LIKE '%css%';</code></pre>
<p>这种方法，因为获取的主体是<code>note</code>，所以将<code>notes</code>去<code>left join</code>了<code>users</code>。</p>
<h5>情况3</h5>
<p>查询所有满足条件的<code>user</code>，同时获取该<code>user</code>所有满足条件的<code>note</code>。</p>
<p><code>Sequelize</code>：</p>
<pre><code>var users = yield User.findAll({
    'include': [Note],
    'where': {
        'created_at': {
            '$lt': new Date()
        }
    }
});
users.forEach(function(user) {
    // user的notes可以通过user.notes访问
    console.log(user);
});</code></pre>
<p><code>SQL</code>：</p>
<pre><code>SELECT `user`.`id`, `user`.`emp_id`, `user`.`created_at`, `user`.`updated_at`,
`notes`.`id` AS `notes.id`, `notes`.`title` AS `notes.title`, `notes`.`created_at` AS `notes.created_at`, `notes`.`updated_at` AS `notes.updated_at`, `notes`.`user_id` AS `notes.user_id`
FROM `users` AS `user` LEFT OUTER JOIN `notes` AS `notes`
ON `user`.`id` = `notes`.`user_id`
WHERE `user`.`created_at` &lt; '2015-11-05 01:51:35';</code></pre>
<p>这种方法获取的主体是<code>user</code>，所以将<code>users</code>去<code>left join</code>了<code>notes</code>。</p>
<h5>一点补充</h5>
<p>关于各种join的区别，可以参考：<a href="http://blog.codinghorror.com/a-visual-explanation-of-sql-joins/" rel="external nofollow noreferrer">http://blog.codinghorror.com/a-visual-explanation-of-sql-joins/</a>。</p>
<p>关于<code>eager loading</code>我想再啰嗦几句。<code>include</code>里面传递的是去取相关模型，默认是取全部，我们也可以再对这个模型进行一层过滤。像下面这样：</p>
<p><code>Sequelize</code>：</p>
<pre><code>// 查询创建时间在今天之前的所有user，同时获取他们note的标题中含有关键字css的所有note
var users = yield User.findAll({
    'include': [
        {
            'model': Note,
            'where': {
                'title': {
                    '$like': '%css%'
                }
            }
        }
    ],
    'where': {
        'created_at': {
            '$lt': new Date()
        }
    }
});</code></pre>
<p><code>SQL</code>：</p>
<pre><code>SELECT `user`.`id`, `user`.`emp_id`, `user`.`created_at`, `user`.`updated_at`,
`notes`.`id` AS `notes.id`, `notes`.`title` AS `notes.title`, `notes`.`created_at` AS `notes.created_at`, `notes`.`updated_at` AS `notes.updated_at`, `notes`.`user_id` AS `notes.user_id`
FROM `users` AS `user` INNER JOIN `notes` AS `notes`
ON `user`.`id` = `notes`.`user_id` AND `notes`.`title` LIKE '%css%'
WHERE `user`.`created_at` &lt; '2015-11-05 01:58:31';</code></pre>
<p>注意：当我们对<code>include</code>的模型加了<code>where</code>过滤时，会使用<code>inner join</code>来进行查询，这样保证只有那些拥有标题含有<code>css</code>关键词<code>note</code>的用户才会返回。</p>
<h2>多对多关系</h2>
<p>在多对多关系中，必须要额外一张关系表来将2个表进行关联，这张表可以是单纯的一个关系表，也可以是一个实际的模型（含有自己的额外属性来描述关系）。我比较喜欢用一个模型的方式，这样方便以后做扩展。</p>
<h3>模型定义</h3>
<p><code>Sequelize</code>：</p>
<pre><code>var Note = sequelize.define('note',
    {
        'title': {
            'type': Sequelize.CHAR(64),
            'allowNull': false
        }
    }
);
var Tag = sequelize.define('tag',
    {
        'name': {
            'type': Sequelize.CHAR(64),
            'allowNull': false,
            'unique': true
        }
    }
);
var Tagging = sequelize.define('tagging',
    {
        'type': {
            'type': Sequelize.INTEGER(),
            'allowNull': false
        }
    }
);

// Note的实例拥有getTags、setTags、addTag、addTags、createTag、removeTag、hasTag方法
Note.belongsToMany(Tag, {'through': Tagging});
// Tag的实例拥有getNotes、setNotes、addNote、addNotes、createNote、removeNote、hasNote方法
Tag.belongsToMany(Note, {'through': Tagging});</code></pre>
<p><code>SQL</code>：</p>
<pre><code>CREATE TABLE IF NOT EXISTS `notes` (
    `id` INTEGER NOT NULL auto_increment ,
    `title` CHAR(64) NOT NULL,
    `created_at` DATETIME NOT NULL,
    `updated_at` DATETIME NOT NULL,
    PRIMARY KEY (`id`)
) ENGINE=InnoDB;

CREATE TABLE IF NOT EXISTS `tags` (
    `id` INTEGER NOT NULL auto_increment ,
    `name` CHAR(64) NOT NULL UNIQUE,
    `created_at` DATETIME NOT NULL,
    `updated_at` DATETIME NOT NULL,
    PRIMARY KEY (`id`)
) ENGINE=InnoDB;

CREATE TABLE IF NOT EXISTS `taggings` (
    `type` INTEGER NOT NULL,
    `created_at` DATETIME NOT NULL,
    `updated_at` DATETIME NOT NULL,
    `tag_id` INTEGER ,
    `note_id` INTEGER ,
    PRIMARY KEY (`tag_id`, `note_id`),
    FOREIGN KEY (`tag_id`) REFERENCES `tags` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
    FOREIGN KEY (`note_id`) REFERENCES `notes` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB;</code></pre>
<p>可以看到，多对多关系中单独生成了一张关系表，并设置了2个外键<code>tag_id</code>和<code>note_id</code>来和<code>tags</code>和<code>notes</code>进行关联。关于关系表的命名，我比较喜欢使用动词，因为这张表是用来表示两张表的一种联系，而且这种联系多数时候伴随着一种动作。比如：用户收藏商品（<code>collecting</code>）、用户购买商品（<code>buying</code>）、用户加入项目（<code>joining</code>）等等。</p>
<h3>增</h3>
<h4>方法1</h4>
<p><code>Sequelize</code>：</p>
<pre><code>var note = yield Note.create({'title': 'note'});
yield note.createTag({'name': 'tag'}, {'type': 0});</code></pre>
<p><code>SQL</code>：</p>
<pre><code>INSERT INTO `notes`
(`id`,`title`,`updated_at`,`created_at`)
VALUES
(DEFAULT,'note','2015-11-06 02:14:38','2015-11-06 02:14:38');

INSERT INTO `tags`
(`id`,`name`,`updated_at`,`created_at`)
VALUES
(DEFAULT,'tag','2015-11-06 02:14:38','2015-11-06 02:14:38');

INSERT INTO `taggings`
(`tag_id`,`note_id`,`type`,`created_at`,`updated_at`)
VALUES
(1,1,0,'2015-11-06 02:14:38','2015-11-06 02:14:38');</code></pre>
<p><code>SQL</code>执行逻辑：</p>
<ul>
<li>在<code>notes</code>表插入记录</li>
<li>在<code>tags</code>表中插入记录</li>
<li>使用对应的值设置外键<code>tag_id</code>和<code>note_id</code>以及关系模型本身需要的属性（<code>type: 0</code>）在关系表<code>tagging</code>中插入记录</li>
</ul>
<p>关系表本身需要的属性，通过传递一个额外的对象给设置方法来实现。</p>
<h4>方法2</h4>
<p><code>Sequelize</code>：</p>
<pre><code>var note = yield Note.create({'title': 'note'});
var tag = yield Tag.create({'name': 'tag'});
yield note.addTag(tag, {'type': 1});</code></pre>
<p><code>SQL</code>：</p>
<pre><code>INSERT INTO `notes`
(`id`,`title`,`updated_at`,`created_at`)
VALUES
(DEFAULT,'note','2015-11-06 02:20:52','2015-11-06 02:20:52');

INSERT INTO `tags`
(`id`,`name`,`updated_at`,`created_at`)
VALUES
(DEFAULT,'tag','2015-11-06 02:20:52','2015-11-06 02:20:52');

INSERT INTO `taggings`
(`tag_id`,`note_id`,`type`,`created_at`,`updated_at`)
VALUES
(1,1,1,'2015-11-06 02:20:52','2015-11-06 02:20:52');</code></pre>
<p>这种方法和上面的方法实际上是一样的。只是我们先手动<code>create</code>了一个<code>Tag</code>模型。</p>
<h4>方法3</h4>
<p><code>Sequelize</code>：</p>
<pre><code>var note = yield Note.create({'title': 'note'});
var tag1 = yield Tag.create({'name': 'tag1'});
var tag2 = yield Tag.create({'name': 'tag2'});
yield note.addTags([tag1, tag2], {'type': 2});</code></pre>
<p><code>SQL</code>：</p>
<pre><code>INSERT INTO `notes`
(`id`,`title`,`updated_at`,`created_at`)
VALUES
(DEFAULT,'note','2015-11-06 02:25:18','2015-11-06 02:25:18');

INSERT INTO `tags`
(`id`,`name`,`updated_at`,`created_at`)
VALUES
(DEFAULT,'tag1','2015-11-06 02:25:18','2015-11-06 02:25:18');

INSERT INTO `tags`
(`id`,`name`,`updated_at`,`created_at`)
VALUES
(DEFAULT,'tag2','2015-11-06 02:25:18','2015-11-06 02:25:18');

INSERT INTO `taggings` (`tag_id`,`note_id`,`type`,`created_at`,`updated_at`)
VALUES
(1,1,2,'2015-11-06 02:25:18','2015-11-06 02:25:18'),
(2,1,2,'2015-11-06 02:25:18','2015-11-06 02:25:18');</code></pre>
<p>这种方法可以进行批量添加。当执行<code>addTags</code>时，实际上就是设置好对应的外键及关系模型本身的属性，然后在关系表中批量的插入数据。</p>
<h3>改</h3>
<p><code>Sequelize</code>：</p>
<pre><code>// 先添加几个tag
var note = yield Note.create({'title': 'note'});
var tag1 = yield Tag.create({'name': 'tag1'});
var tag2 = yield Tag.create({'name': 'tag2'});
yield note.addTags([tag1, tag2], {'type': 2});
// 将tag改掉
var tag3 = yield Tag.create({'name': 'tag3'});
var tag4 = yield Tag.create({'name': 'tag4'});
yield note.setTags([tag3, tag4], {'type': 3});</code></pre>
<p><code>SQL</code>：</p>
<pre><code>/* 前面添加部分的sql，和上面一样*/
INSERT INTO `notes`
(`id`,`title`,`updated_at`,`created_at`)
VALUES
(DEFAULT,'note','2015-11-06 02:25:18','2015-11-06 02:25:18');

INSERT INTO `tags`
(`id`,`name`,`updated_at`,`created_at`)
VALUES
(DEFAULT,'tag1','2015-11-06 02:25:18','2015-11-06 02:25:18');

INSERT INTO `tags`
(`id`,`name`,`updated_at`,`created_at`)
VALUES
(DEFAULT,'tag2','2015-11-06 02:25:18','2015-11-06 02:25:18');

INSERT INTO `taggings`
(`tag_id`,`note_id`,`type`,`created_at`,`updated_at`)
VALUES
(1,1,2,'2015-11-06 02:25:18','2015-11-06 02:25:18'),
(2,1,2,'2015-11-06 02:25:18','2015-11-06 02:25:18');

/* 更改部分的sql */
INSERT INTO `tags`
(`id`,`name`,`updated_at`,`created_at`)
VALUES
(DEFAULT,'tag3','2015-11-06 02:29:55','2015-11-06 02:29:55');

INSERT INTO `tags`
(`id`,`name`,`updated_at`,`created_at`)
VALUES
(DEFAULT,'tag4','2015-11-06 02:29:55','2015-11-06 02:29:55');

/* 先删除关系 */
DELETE FROM `taggings`
WHERE `note_id` = 1 AND `tag_id` IN (1, 2);

/* 插入新关系 */
INSERT INTO `taggings`
(`tag_id`,`note_id`,`type`,`created_at`,`updated_at`)
VALUES
(3,1,3,'2015-11-06 02:29:55','2015-11-06 02:29:55'),
(4,1,3,'2015-11-06 02:29:55','2015-11-06 02:29:55');</code></pre>
<p>执行逻辑是，先将<code>tag1</code>、<code>tag2</code>在关系表中的关系删除，然后再将<code>tag3</code>、<code>tag4</code>对应的关系插入关系表。</p>
<h3>删</h3>
<p><code>Sequelize</code>：</p>
<pre><code>// 先添加几个tag
var note = yield Note.create({'title': 'note'});
var tag1 = yield Tag.create({'name': 'tag1'});
var tag2 = yield Tag.create({'name': 'tag2'});
var tag3 = yield Tag.create({'name': 'tag2'});
yield note.addTags([tag1, tag2, tag3], {'type': 2});

// 删除一个
yield note.removeTag(tag1);

// 全部删除
yield note.setTags([]);</code></pre>
<p><code>SQL</code>：</p>
<pre><code>/* 删除一个 */
DELETE FROM `taggings` WHERE `note_id` = 1 AND `tag_id` IN (1);

/* 删除全部 */
SELECT `type`, `created_at`, `updated_at`, `tag_id`, `note_id`
FROM `taggings` AS `tagging`
WHERE `tagging`.`note_id` = 1;

DELETE FROM `taggings` WHERE `note_id` = 1 AND `tag_id` IN (2, 3);</code></pre>
<p>删除一个很简单，直接将关系表中的数据删除。</p>
<p>全部删除时，首先需要查出关系表中<code>note_id</code>对应的所有数据，然后一次删掉。</p>
<h3>查</h3>
<h4>情况1</h4>
<p>查询<code>note</code>所有满足条件的<code>tag</code>。</p>
<p><code>Sequelize</code>：</p>
<pre><code>var tags = yield note.getTags({
    //这里可以对tags进行where
});
tags.forEach(function(tag) {
    // 关系模型可以通过tag.tagging来访问
    console.log(tag);
});</code></pre>
<p><code>SQL</code>：</p>
<pre><code>SELECT `tag`.`id`, `tag`.`name`, `tag`.`created_at`, `tag`.`updated_at`,
`tagging`.`type` AS `tagging.type`, `tagging`.`created_at` AS `tagging.created_at`, `tagging`.`updated_at` AS `tagging.updated_at`, `tagging`.`tag_id` AS `tagging.tag_id`, `tagging`.`note_id` AS `tagging.note_id`
FROM `tags` AS `tag`
INNER JOIN `taggings` AS `tagging`
ON
`tag`.`id` = `tagging`.`tag_id` AND `tagging`.`note_id` = 1;</code></pre>
<p>可以看到这种查询，就是执行一个<code>inner join</code>。</p>
<h4>情况2</h4>
<p>查询所有满足条件的<code>tag</code>，同时获取每个<code>tag</code>所在的<code>note</code>。</p>
<p><code>Sequelize</code>：</p>
<pre><code>var tags = yield Tag.findAll({
    'include': [
        {
            'model': Note
            // 这里可以对notes进行where
        }
    ]
    // 这里可以对tags进行where
});
tags.forEach(function(tag) {
    // tag的notes可以通过tag.notes访问，关系模型可以通过tag.notes[0].tagging访问
    console.log(tag);
});</code></pre>
<p><code>SQL</code>：</p>
<pre><code>SELECT `tag`.`id`, `tag`.`name`, `tag`.`created_at`, `tag`.`updated_at`,
`notes`.`id` AS `notes.id`, `notes`.`title` AS `notes.title`, `notes`.`created_at` AS `notes.created_at`, `notes`.`updated_at` AS `notes.updated_at`,
`notes.tagging`.`type` AS `notes.tagging.type`, `notes.tagging`.`created_at` AS `notes.tagging.created_at`, `notes.tagging`.`updated_at` AS `notes.tagging.updated_at`, `notes.tagging`.`tag_id` AS `notes.tagging.tag_id`, `notes.tagging`.`note_id` AS `notes.tagging.note_id`
FROM `tags` AS `tag`
LEFT OUTER JOIN
(
    `taggings` AS `notes.tagging` INNER JOIN `notes` AS `notes`
    ON
    `notes`.`id` = `notes.tagging`.`note_id`
)
ON `tag`.`id` = `notes.tagging`.`tag_id`;</code></pre>
<p>这个查询就稍微有点复杂。首先是<code>notes</code>和<code>taggings</code>进行了一个<code>inner join</code>，选出<code>notes</code>；然后<code>tags</code>和刚<code>join</code>出的集合再做一次<code>left join</code>，得到结果。</p>
<h4>情况3</h4>
<p>查询所有满足条件的<code>note</code>，同时获取每个<code>note</code>所有满足条件的<code>tag</code>。</p>
<p><code>Sequelize</code>：</p>
<pre><code>var notes = yield Note.findAll({
    'include': [
        {
            'model': Tag
            // 这里可以对tags进行where
        }
    ]
    // 这里可以对notes进行where
});
notes.forEach(function(note) {
    // note的tags可以通过note.tags访问，关系模型通过note.tags[0].tagging访问
    console.log(note);
});</code></pre>
<p><code>SQL</code>：</p>
<pre><code>SELECT
`note`.`id`, `note`.`title`, `note`.`created_at`, `note`.`updated_at`,
`tags`.`id` AS `tags.id`, `tags`.`name` AS `tags.name`, `tags`.`created_at` AS `tags.created_at`, `tags`.`updated_at` AS `tags.updated_at`,
`tags.tagging`.`type` AS `tags.tagging.type`, `tags.tagging`.`created_at` AS `tags.tagging.created_at`, `tags.tagging`.`updated_at` AS `tags.tagging.updated_at`, `tags.tagging`.`tag_id` AS `tags.tagging.tag_id`, `tags.tagging`.`note_id` AS `tags.tagging.note_id`
FROM `notes` AS `note`
LEFT OUTER JOIN
(
    `taggings` AS `tags.tagging` INNER JOIN `tags` AS `tags`
    ON
    `tags`.`id` = `tags.tagging`.`tag_id`
)
ON
`note`.`id` = `tags.tagging`.`note_id`;</code></pre>
<p>这个查询和上面的查询类似。首先是<code>tags</code>和<code>taggins</code>进行了一个<code>inner join</code>，选出<code>tags</code>；然后<code>notes</code>和刚<code>join</code>出的集合再做一次<code>left join</code>，得到结果。</p>
<h1>其他没有涉及东西</h1>
<p>这篇文章已经够长了，但是其实我们还有很多没有涉及的东西，比如：聚合函数及查询（<code>having</code>、<code>group by</code>）、模型的验证（<code>validate</code>）、定义钩子（<code>hooks</code>）、索引等等。</p>
<p>这些主题下次再来写写。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 11:35:43</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Sequelize 和 MySQL 对照的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqA6JkM.html" rel="bookmark">mysql设置主键出错，可我对照网上教程找不出错误</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 mysql设置主键出错,可我对照网上教程找不出错误 请告诉我哪儿错了,谢谢! 解决方案 primary key('book_id'),//这一行首先将book_id的单引号去掉,然后将后面的逗号去掉就可以了,我将改后的代码运行成功了 另外你可以用可视化管理工具来操作的: 如果回答对你有帮助,请采纳 解决方案二: 是不是内置错误或者要区分的大小写错误 解决方案三: 我觉得还是用一个可视化软件操作方便些的 解决方案四: 第五行primary key后边的逗号去掉			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPWwrlM.html" rel="bookmark">MongoDB与MySQL常用操作语句对照&lowbar;MongoDB</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.MongoDB对MySQL常用的SQL语句对应的实现 复制代码 代码如下: -------------- MySQL: SELECT * FROM user Mongo: db.user.find() -------------- MySQl: SELECT * FROM user WHERE name = 'foobar' Mongo: db.user.find({ 'name' : 'foobar' }) -------------- MySql: INSERT INTO user ('			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MR1XLdb.html" rel="bookmark">MySQL配置文件my&period;cnf中文版对照&lowbar;Mysql</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				#BEGIN CONFIG INFO #DESCR: 4GB RAM, 只使用InnoDB, ACID, 少量的连接, 队列负载大 #TYPE: SYSTEM #END CONFIG INFO # # 此mysql配置文件例子针对4G内存 # 主要使用INNODB #处理复杂队列并且连接数量较少的mysql服务器 # # 将此文件复制到/etc/my.cnf 作为全局设置, # mysql-data-dir/my.cnf 作为服务器指定设置 # (@localstatedir@ for this			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pd0YW6p.html" rel="bookmark">MYSQL常见出错代码对照&lowbar;Mysql</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				常见错误! 1016错误:文件无法打开,使用后台修复或者使用phpmyadmin进行修复. 1044错误:数据库用户权限不足,请联系空间商解决 1045错误:数据库服务器/数据库用户名/数据库名/数据库密码错误,请联系空间商检查帐户. 1054错误:程序文件跟数据库有冲突,请使用正确的程序文件上传上去覆盖. 1146错误:数据表缺失,请恢复备份数据. 1005:创建表失败 1006:创建数据库失败 1007:数据库已存在,创建数据库失败 1008:数据库不存在,删除数据库失败 1009:不能删除			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/0zGZnEp.html" rel="bookmark">【转载】MySQL复制的概述、安装、故障、技巧、工具</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				概述 首先主服务器把数据变化记录到主日志,然后从服务器通过I/O线程读取主服务器上的主日志,并且把它写入到从服务器的中继日志中,接着SQL线程读取中继日志,并且在从服务器上重放,从而实现MySQL复制.具体如下图所示: MySQL复制 整个过程反映到从服务器上,对应三套日志信息,可在从服务器上用如下命令查看: mysql&gt; SHOW SLAVE STATUS;   Master_Log_File &amp; Read_Master_Log_Pos:下一个传输的主日志信息. Relay_Master_			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/rz4eGNb.html" rel="bookmark">Mysql日期和时间总结</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				MySQL日期数据类型.MySQL时间类型使用总结 1,TIMESTAMP DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP 在创建新记录和修改现有记录的时候都对这个数据列刷新 2,TIMESTAMP DEFAULT CURRENT_TIMESTAMP 在创建新记录的时候把这个字段设置为当前时间,但以后修改时,不再刷新它 3,TIMESTAMP ON UPDATE CURRENT_TIMESTAMP 在创建新记录的时候把这个字段设置为0,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/vbQkxOp.html" rel="bookmark">Dreamhost的MySQL存在限制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在购买DreamHost的时候,虽然上面标明了MySQL数据库是Unlimited(无限制),但是实际使用的时候却是有限制的,DreamHost的DNS稳定性也不太好,使用的时候需要多加注意. 以我的切身体会,我使用WordPress MU在DreamHost搭建一个免费托管博客服务,由于WordPress MU的特性,每新增一个用户都要在数据库中建立十多张表,因此,仅仅两千多个注册用户的WordPress MU就有了两万多张表,虽然使用WP Super Cache可以使得大量访问不需用访问数据			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/gpkBxOM.html" rel="bookmark">MySQL查询优化技术系列讲座之使用索引</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				索引是提高查询速度的最重要的工具.当然还有其它的一些技术可供使用,但是一般来说引起最大性能差异的都是索引的正确使用.在MySQL邮件列表中,人们经常询问那些让查询运行得更快的方法.在大多数情况下,我们应该怀疑数据表上有没有索引,并且通常在添加索引之后立即解决了问题.当然,并不总是这样简单就可以解决问题的,因为优化技术本来就并非总是简单的.然而,如果没有使用索引,在很多情况下,你试图使用其它的方法来提高性能都是在浪费时间.首先使用索引来获取最大的性能提高,接着再看其它的技术是否有用. 这一部分讲述			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/rz4LVjz.html" rel="bookmark">MySQL数据目录结构（1）转</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				mysql|数据|数据目录 MySQL数据目录结构(1)[晏子]从概念上讲,大多数关系数据库系统是相似的:它们有一系列数据库组成,每个数据库包含一系列数据库表,但每个系统有各自组织其管理的数据方式,MySQL也不例外.缺省地,所有由MySQL服务器mysqld管理的数据存储在一个称为MySQL数据目录的地方,所有数据库都存放在哪儿,也包括提供服务器操作信息的状态文件.如果你对一个MySQl安装执行管理任务,你应该熟知数据目录的布局及用途.本文介绍下列专题: 如何确定数据目录的位置. 服务器如何组			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2pL8r0p.html" rel="bookmark" class="title">奇虎360正式发布搜索独立APP&OpenCurlyDoubleQuote;360搜索&rdquo;</a>
					<div>
						网易科技讯 6月3日消息,360公司今日正式发布移动搜索独立APP--360搜索,进而提速360移动搜索战略. 360搜索APP集成了网页.新闻.视频.游戏.壁纸.APP.地图等内容的搜索功能,并支持 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2y4WBz.html" rel="bookmark" class="title">Sql Server如何统计表中某年某月某个值有多少</a>
					<div>
						比如:统计表AA中YWLX列在某年某月每种类型各有多少? select year(AA_YWRQ) as YEARS, month(AA_YWRQ) AS Months ,AA_YWLX,count( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyrOldp.html" rel="bookmark" class="title">实现简单的CSharpShell -- OrcShell &lpar;2&rpar; 类型浏览、执行代码片断与其它</a>
					<div>
						二.类型管理 1.程序集与类型的管理 在Context初始化时便将AppDomain中的类型全部加载并交给TypeManager管理: public Context() { -- TypeManage ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEl20Jz.html" rel="bookmark" class="title">制作甜美的彩色雪糕字</a>
					<div>
						雪糕字制作起来要比看上去要复杂,表面的纹理不是用图层样式就可以完成的.需要用画笔或素材等慢慢加上去,再用图层样式等做出光感和立体效果.   最终效果 1.新建一个画布选择渐变工具(g)然后拉一个径向渐 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJ7PXVb.html" rel="bookmark" class="title">如何检查Dreamweaver站点中链接错误</a>
					<div>
						  1.在&quot;站点&quot;菜单中找到&quot;检查站点范围的链接&quot;,如下图所示. 2.点击&quot;检查站点范围的链接&quot;后,在软件下方会出现链接检查窗口,它可以快速 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAa5qvM.html" rel="bookmark" class="title">电脑装机硬盘分区、格式化通用方法大全</a>
					<div>
						  常用的分区方式,以便新手用户能够快速掌握. 需要说明的是,目前常见分区格式有GPT和MBR两种,分别对应UEFI和Legacy启动模式,一般来说近几年的新机器默认都是UEFI+GPT的模式,因为G ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKk8QZb.html" rel="bookmark" class="title">查找Oracle高消耗语句的方法</a>
					<div>
						 这篇文章主要介绍了查找Oracle高消耗语句的方法,需要的朋友可以参考下 在运行下面的脚本之前需要先用生成AWR报告的SQL(程序脚本一般保存在$ORACLE_HOME下的rdbms/admin中, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLaxeaz.html" rel="bookmark" class="title">集合类-java中为什么不直接用Collection接口，而是还要再造一个他们相应的抽象类？</a>
					<div>
						问题描述 java中为什么不直接用Collection接口,而是还要再造一个他们相应的抽象类? 诸如HashMap.ArrayList等具体类,都是直接继承自AbstractMap或AbstractL ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlQLJOp.html" rel="bookmark" class="title">ios-NSInvalidArgumentException引发应用崩溃</a>
					<div>
						问题描述 NSInvalidArgumentException引发应用崩溃 看一下我的代码,从网站服务器获得数据,但是崩溃了: - (void)loadDataSource { // Request  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvr5wNM.html" rel="bookmark" class="title">JNDI数据库连接池</a>
					<div>
						JNDI的全称是java命名与目录接口(Java Naming and Directory Interface),是一个应用程序设计的API,为开发人员提供了查找和访问各种命名和目录服务的通用.统一的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0Rxv8z.html" rel="bookmark" class="title">《Ext JS实战》&mdash;&mdash;1&period;3 框架概览</a>
					<div>
						1.3 框架概览 Ext JS作为一个框架,不仅提供了UI部件,还提供了许多其他特性.这些内容可以分成6大部分,即Ext JS核心.UI组件.Web远程调用.数据服务.拖放以及通用工具.图1-4说明了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE4gX6z.html" rel="bookmark" class="title">高可用笔记（0）前言</a>
					<div>
						上周接到BOSS的order:把我们的产品做一个高可用方案. 于是折腾了一周多,终于差不多试验成功了,好不容易折腾出来的成果记录一下防止时间一长就忘记. 产品的架构有点小小复杂,做HA涉及的方面比较多 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmK88wb.html" rel="bookmark" class="title">对链表头写入next，一直显示0xC0000005&colon; 写入位置 0x00000068 时发生访问冲突</a>
					<div>
						问题描述 对链表头写入next,一直显示0xC0000005: 写入位置 0x00000068 时发生访问冲突 代码如下 #include #include #define ElementType i ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDndLXM.html" rel="bookmark" class="title">安全隐患无处不在 你中枪了吗&quest;</a>
					<div>
						&quot;扫码了,扫码了,扫码注册送礼品.&quot;相信这样的吆喝你已经司空见惯见怪不怪了,也许你会因为礼品的诱惑扫码注册,但你是否想过如果对方不是一个合规的平台,你的个人信息是否会因此而泄露,从 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq7O1ez.html" rel="bookmark" class="title">《面向对象分析与设计》一1&period;6关于统一建模语言UML</a>
					<div>
						1.6关于统一建模语言UML UML最初是在多种面向对象分析与设计方法相互融合的基础上形成的,后来发展成为也可以用于业务建模以及其他非软件系统建模的语言.它于1997年11月被对象管理组织(Objec ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNnk0mM.html" rel="bookmark" class="title">练习练到手抽筋叹一句SKY，保重！</a>
					<div>
						多玩游戏网讯(记者 巫妖康葛斯)就在今天凌晨,著名的魔兽选手人皇SKY在其微博上留言到由于练习了一天,手指过多的点击鼠标,出现了手抽筋的迹象.不得不说电子竞技果然是高强度的训练.在这里我们希望SKY能 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwJD7vp.html" rel="bookmark" class="title">iOS开发UI篇&mdash;popoverController使用注意</a>
					<div>
						iOS开发UI篇-popoverController使用注意 iOS开发UI篇-popoverController使用注意 一.设置尺寸 提示:不建议,像下面这样吧popover的宽度和高度写死. 1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwJ9nvp.html" rel="bookmark" class="title">【转载】如何：在各种字符串类型之间进行转换</a>
					<div>
						[转载]如何:在各种字符串类型之间进行转换2008-03-19 17:36如何:在各种字符串类型之间进行转换 本主题演示如何将各种 Visual C++ 字符串类型转换为其他字符串.可以转换的字符串类 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b227DZb.html" rel="bookmark" class="title">html5-bootstrap的选中问题（active类）</a>
					<div>
						问题描述 bootstrap的选中问题(active类) 请问一下在多个标签下选中的标签一般不是用active类表示选中吗,那我选中了一个标签要再选中另外一个标签,那之前被选过的标签要怎么修改去除被选 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeoJyOM.html" rel="bookmark" class="title">《破茧成蝶&mdash;&mdash;用户体验设计师的成长之路》&mdash;2&period;2&emsp;用户体验设计师的价值</a>
					<div>
						2.2 用户体验设计师的价值 破茧成蝶--用户体验设计师的成长之路 一个好的用户体验设计师,一定是一个热爱生活.有激情.有梦想.喜欢解决问题的人.他的头脑中总是充满了各种各样新奇.有趣.靠谱的想法.他 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyWgRJz.html" rel="bookmark" class="title">js文件缓存之版本管理详解&lowbar;基础知识</a>
					<div>
						近几个月来的工作是一个交易系统持续改进项目,迭代发布周期大约为2~3周.最近一次迭代是V16版,在礼拜三完成发布.不幸的是,第二天上午就被老大逮过去.原来老大从生产中揪出了一个bug,大致的问题如下: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGr083p.html" rel="bookmark" class="title">centos mysql 修改数据库目录&lowbar;Mysql</a>
					<div>
						MySQL默认的数据文件存储目录 /var/lib/mysql,现在要把目录修改为/home/data/mysqlcd /homemkdir data //在home目录下建data目录mysqlad ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKqlE7p.html" rel="bookmark" class="title">javascript中sort&lpar;&rpar; 方法使用详解&lowbar;javascript技巧</a>
					<div>
						语法:arrayObject.sort(sortby):参数sortby可选.规定排序顺序.必须是函数. sort() 方法用于对数组的元素进行排序. 如果调用该方法时没有使用参数,将按字母顺序对数组 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0Nyg0z.html" rel="bookmark" class="title">CSS3实现10种Loading效果</a>
					<div>
						原文:CSS3实现10种Loading效果 昨晚用CSS3实现了几种常见的Loading效果,虽然很简单,但还是分享一下,顺便也当是做做笔记-- 第1种效果: 代码如下: &lt;div class= ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqWx4Kz.html" rel="bookmark" class="title">Check the result mapping for the 1 property</a>
					<div>
						问题描述 各位大虾,小弟这两天为这个问题寝食难安.万恶的IBM. websphere6.1+DB2 v9.1+ibatis2.3.4 配置文件如下:sqlmapconfig.xml : &lt;sql ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj84JWp.html" rel="bookmark" class="title">adsl上网问题</a>
					<div>
						问题描述 我家用的是无线猫上网,接入的信号时正常的,可是我输入用户名和密码时总是报错678这是怎么没回事呢,其他设备都正常机子也正常,网路信号也正常..					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyWl1dz.html" rel="bookmark" class="title">几行代码创建属于你自己的SQL数据库</a>
					<div>
						创建数据库有多重方法,如可以使用企业管理器创建数据库,也可以使用向导创建数据库.上面两种方法操作都很简单,但却有一个很大的缺点就是他很难大规模重复.换句话说,如果你创建一个准备重新分布到世界各地的数据 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mqg2a3z.html" rel="bookmark" class="title">atom markdown转换PDF 解决AssertionError&colon; html-pdf&colon; Failed to load PhantomJS module</a>
					<div>
						atom编辑器markdown转换PDF 解决AssertionError: html-pdf: Failed to load PhantomJS module. You have to set th ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4YXK8b.html" rel="bookmark" class="title">打印窗体时显示不完全</a>
					<div>
						问题描述 窗口使用PrintForm打印,但是一旦窗体在屏幕上现实不完,打印就会不完全,有什么解决方法吗?或者帮我出个招,现在要打印的东西都在窗体上显示着,但有可能客户的电脑上显示不全这个窗体 解决方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Yl0qp.html" rel="bookmark" class="title">基于Asp&period;net页面的WF Designer或Monitor</a>
					<div>
						问题描述 我在JonFlander的博客上看到了相关资料:http://www.jonflanders.com/?p=1308但源码在masteringbiztalk网站上,更悲催的是masterin ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.085 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
